#ifndef GFXAPI_H_
#define GFXAPI_H_

class Mesh;
class Texture;
class ShaderProgram;
class Shader;

enum Gfx_API {
	GFX_GL,
	GFX_VK
};

extern void (*gfx_clear)(float r, float g, float b);
extern void (*gfx_viewport)(int x, int y, int width, int height);

bool gfx_init(Gfx_API api);
void gfx_cleanup();

Mesh *gfx_create_mesh();
Texture *gfx_create_texture();
ShaderProgram *gfx_create_shader_program();
Shader *gfx_create_shader();
char *gfx_get_shader_path();

#endif // GFXAPI_H_