#ifndef RENDERER_H_
#define RENDERER_H_

class OrbitCamera;
class Object;
class Scene;
class ShaderProgram;

class Renderer {
protected:
	int diff_loc;
	int spec_loc;
	int shin_loc;
	int mmviewproj_loc;
	int mview_loc;

	ShaderProgram *sprog;

	Texture *skytex, *dskytex;

	virtual void draw_object(Object *object) const;
	virtual void draw_skybox();

public:
	Scene *scene;
	OrbitCamera *camera;

	Renderer();
	virtual ~Renderer();

	virtual bool create();
	virtual void draw() const;

	virtual void set_sky_tex(Texture *stex);
	virtual void set_diffuse_sky_tex(Texture *dstex);
};

#endif // RENDERER_H_